#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>

#define PORT 3490 // the port client will be connecting to 

#define MAXDATASIZE 100 // max number of bytes we can get at once 

int main(int argc, char *argv[])
{
  int sockfd, numbytes, index = 0, numcar;  
  char *buf, autre_buf[6], buffer[1024];
  struct hostent *he;
  struct sockaddr_in their_addr; // connector's address information 
  FILE *file;
  char character = 'a';
  
  if (argc != 2) {
    fprintf(stderr,"usage: client data_file\n");
    exit(1);
  }

  file = fopen(argv[1], "r");
  if (!file) {
    fprintf(stderr, "Can't open the file %s", argv[1]);
    exit(1);
  }
  
  if ((he=gethostbyname("cocat1.u-strasbg.fr")) == NULL) {  // get the host info 
    perror("gethostbyname");
    exit(1);
  }
  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("socket");
    exit(1);
  }
  
  their_addr.sin_family = AF_INET;    // host byte order 
  their_addr.sin_port = htons(PORT);  // short, network byte order 
  their_addr.sin_addr = *((struct in_addr *)he->h_addr);
  memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct 
  
  if (connect(sockfd, (struct sockaddr *)&their_addr,
	      sizeof(struct sockaddr)) == -1) {
    perror("connect");
    exit(1);
  }
  // send the control to server.
  int numero = 0;
  while (character != EOF) {
    autre_buf[0] = 'a';
    while (strcmp(autre_buf, "finish") && character != EOF) {
      buf = (char *)(malloc(100*sizeof(char)));
      if (!buf) {
	fprintf(stderr, "Not enough memory buf of client.");
	exit(1);
	}
      index = 0;
      character = (char)(fgetc(file));
      while(character != '\n' && character != EOF) {
	*(buf + index++) = character;
	character = (char)(fgetc(file));
      }
      if (character != EOF) {
	*(buf + index) = '\0';
	// printf("%s ; numero = %d\n", buf, numero++);
	if (send(sockfd, buf, strlen(buf), 0) == -1) {
	  perror("recv");
	  exit(1);
	}
	free(buf);
	// printf("reception ordre.\n");
	recv(sockfd, autre_buf, 7, 0);
      }
      else {
	send(sockfd, "finish", 6, 0);
	recv(sockfd, autre_buf, 6, 0);
      }
    }
    // Reception the results from server. 
    buffer[0] = 'a';
    while (strcmp(buffer, "finish")) {
      //printf("reception reponse\n");
      if ((numcar = recv(sockfd, buffer, 1023, 0)) == -1)
	perror("send");
      buffer[numcar]='\0';
      if (strcmp(buffer, "finish")) {
	printf("%s", buffer);
	
      }
      send(sockfd, "encore", 7, 0);
    }
  }
    // Communication is terminated.
  close(sockfd);
  return 0;
} 
